   MEMBER()

   include('winerr.def')
   include('winapi.inc','Equates')

   MAP
      MODULE('GetError')
         FormatMessage(UNSIGNED,ULONG,UNSIGNED,UNSIGNED,LONG pBuffer,UNSIGNED,LONG pArguments),UNSIGNED,PASCAL,NAME('FormatMessageA'),PROC
         LoadLibraryEx(LONG pLibFileName,HANDLE,DWORD),HINSTANCE,PASCAL,NAME('LoadLibraryExA')
         GetModuleHandle(LONG pModuleName),HMODULE,PASCAL,NAME('GetModuleHandleA')
         GetLastError(),DWORD,PASCAL
      END
   END

WinError.Init Procedure
   Code
   IF ~SELF.IsInit
      SELF.LibraryQueue &= NEW(LibraryQueueType)
      SELF.IsInit = True
   END

WinError.AddLibrary Procedure(STRING Library)
   CODE
   IF CLIP(Library) <> ''
      SELF.LibraryQueue.Name = CLIP(Library)
      GET(SELF.LibraryQueue,+SELF.LibraryQueue.Name)
      IF ERRORCODE()
         ADD(SELF.LibraryQueue,+SELF.LibraryQueue.Name)
?        ASSERT(~ERRORCODE())
      END
   END

WinError.RemoveLibrary Procedure(STRING Library)
   CODE
   SELF.LibraryQueue.Name = CLIP(Library)
   GET(SELF.LibraryQueue,+SELF.LibraryQueue.Name)
   IF ~ERRORCODE()
      DELETE(SELF.LibraryQueue)
?     ASSERT(~ERRORCODE())
   END

WinError.RemoveAllLibrary Procedure
   CODE
   FREE(SELF.LibraryQueue)

WinError.GetError Procedure(<STRING Library>)
MessageText    STRING(256)
   CODE
   IF ~OMITTED(2) THEN SELF.AddLibrary(Library) .
   IF SELF.EnableMessage
      MessageText = SELF.ErrMessage()
      IF CLIP(MessageText) <> ''
         Message(MessageText,'Warning !',ICON:Hand)
      END
   END
   RETURN SELF.LastErrorCode

WinError.ErrCode  Procedure
   Code
   SELF.LastErrorCode = GetLastError()
   Return SELF.LastErrorCode

WinError.Kill  Procedure
   Code
   IF ~SELF.LibraryQueue &= NULL Then Dispose(SELF.LibraryQueue) .

WinError.Destruct  Procedure
   Code
   SELF.Kill

WinError.ErrMessage  Procedure
FormatFlag     DWORD
MessageBuffer  CSTRING(512)
RetVal         STRING(SIZE(MessageBuffer)+8)
Idx            LONG
Find           BYTE
   Code
   FormatFlag  = BOR(BOR(FORMAT_MESSAGE_FROM_SYSTEM,FORMAT_MESSAGE_IGNORE_INSERTS),FORMAT_MESSAGE_MAX_WIDTH_MASK)
   IF ~FormatMessage(FormatFlag,0,SELF.LastErrorCode,0,ADDRESS(MessageBuffer),SIZE(MessageBuffer),0)
      LOOP Idx = 1 TO Records(SELF.LibraryQueue)
         Get(SELF.LibraryQueue,Idx)
?           ASSERT(~ERRORCODE())
         IF FormatMessage(BOR(FormatFlag,FORMAT_MESSAGE_FROM_HMODULE),GetModuleHandle(ADDRESS(SELF.LibraryQueue.Name)),SELF.LastErrorCode,0,ADDRESS(MessageBuffer),SIZE(MessageBuffer),0)
            Find = True ;  Break
         END
      END
   ELSE
      Find = True
   END
   IF Find
      RetVal = SELF.LastErrorCode&': '&MessageBuffer
   ELSE
      RetVal = SELF.LastErrorCode
   END
   Return CLIP(RetVal)